/* CS 472/672 Assignment #1 - main.c file */

/* These are the only header files you should need to use. */
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <time.h>
#include "matrhs.h"


int main(int argc,char **args)
{
    char *usageMessage =
         "Usage: ./programOpt size  or  ./programDebug size \n"
         "       size = the (square) grid size in one dimension.\n";

    int     n;           /* Number of grid points in one dimension */
    int     N;           /* Actual number of grid nodes. */
    int     i,j;         /* Loop counters for display and output */

    int     *ia,*ja;     /* Usual ia,ja pointer arrays. You generate these */
    double  *a,*b;       /* Coefficients of the matrix a and RHS b. */

    FILE    *output;     /* Output file for the final matrix (in MATLAB format) */

    clock_t beforeTime,  /* Timer value before calling matrix() */
            afterTime;   /* Timer value after calling source() */


    if (argc==2) {
      n = atoi(args[1]);
    }
    else {
      printf("%s",usageMessage);
      exit(1);
    }


    /* Define grid size and matrix size. */
    printf("Heat Equation Setup for nx, ny = %d.\n",n);
    N = n*n;


    /* Allocate space for arrays ia, ja, a, and b. */
    ia = (int *) malloc((N+1)*sizeof(int));
    ja = (int *) malloc(5*N*sizeof(int));
     a = (double *) malloc(5*N*sizeof(double));
     b = (double *) malloc(N*sizeof(double));


    /* Construct iaja structure and RHS, and time the procedure */
    beforeTime = clock();
    printf("Time before calling matrix() = %12.4f.\n",
           (double) beforeTime/(double) CLOCKS_PER_SEC);

    matrix(ia, ja, a, n);
    source(b, n);

    afterTime = clock();
    printf("Time after calling source() = %12.4f.\n"
           "Time required for setup = %12.4f\n\n",
           (double) afterTime/(double) CLOCKS_PER_SEC,
           (double) (afterTime - beforeTime)/(double) CLOCKS_PER_SEC);


    /* Output matrix and RHS to screen. You can use this for debugging. */
    /*
    for (i=0; i<N; i++) {
       printf("node: %d\n",i);
       printf(" neighbours ");
       for (j=ia[i]; j<ia[i+1]; j++) printf(" %d(%f) ",ja[j],a[j]);
       printf("\n");
    }
    for (i=0; i<N; i++) printf("b[%d]=%f\n",i,b[i]);
    */


    /* Dump all data to "output.m" file. */
    /*
    printf("Writing output to output.m.\n");
    output=fopen("output.m","w");
    fprintf(output,"B=[\n");
    for (i=0; i<N; i++) {
       for (j=ia[i]; j<ia[i+1]; j++) {
          fprintf(output,"%10d%10d%25.14e\n",i+1,ja[j]+1,a[j]);
       }
    }
    fprintf(output,"];\n");
    fprintf(output,"b=[\n");
    for (i=0; i<N; i++) fprintf(output,"%25.14e\n",b[i]);
    fprintf(output,"];\n");
    fclose(output);
    */


    /* Free space */
    free(ia); free(ja); free(a); free(b);

    return 0;
}
